// ========================== FREE INTERFACE=============================== //
// Type: free											   																												//
// Just provide a container and the plugin does whatever it wants to it																		//
// =================================================================== //

#ifndef _IFREE_
#define _IFREE_

#include <map>
#include <string>
#include <vector>

#include <string>
#include <gtk/gtk.h>

#include "gloobus-preview-interface-main.h"

using namespace std;

class iFree : public interface
{
	protected:
	//string			 m_filename;							//From class interface


	public:
										~iFree					( void );
										
										
			//Functions implemented by plugin
			virtual void				draw_free ( GtkContainer * container ) = 0;		//The plugin will use this container to draw  whatever it wants

			//Virtual Functions implemented from interface
			virtual int 				get_width				( void ) = 0;		// Plugin provides it
			virtual int 				get_height				( void ) = 0;		// Plugin provides it
			virtual void				load					( void );

			virtual void				draw					( GtkContainer * container );
			virtual void			end			( void );
			
									
	private:
			void 						draw_file_info 			( GtkContainer * container );
			


};

//==============  CLASS FACTORIES DEFINITIONS================================= //

typedef iFree* create_t_free();																	//CREATE PLUGIN
typedef void destroy_t_free(iFree*);							   								//DESTROY PLUGIN
	
extern map<string, create_t_free *, less<string> > factory_free;		   					//MAP WITH NAME AND CONSTRUCTOR
extern map<string, destroy_t_free *, less<string> > factoryDestroy_free; 					//MAP WITH NAME AND DESTRUCTOR
extern vector<plugin_filetype> pluginVector;				   		 	   					//VECTOR TO STORE WICH FILETYPE READ EACH PLUGIN

#endif
