// ========================== IMAGE INTERFACE ======================== //
// Type: free											   //
// =================================================================== //

#ifndef _ILIST_
#define _ILIST_

#include <map>
#include <string>
#include <vector>

#include <string>
#include <gtk/gtk.h>

#include "gloobus-preview-interface-main.h"

using namespace std;

class iList : public interface
{
	protected:
	//string			 m_filename;							//From class interface
	GdkPixbuf 			*m_pixbuf;
	//GtkWidget 			*m_image;
	//GtkWidget 			*m_image_container;

	public:
	//These next virtual functions musth be implemented for iDocument plugins
	virtual GdkPixbuf*		get_pixbuf    () = 0;					//Developed by the plugins
	virtual int 			get_n_items   () = 0;
	virtual int 			get_n_columns () = 0;
	virtual string 			get_item	  (int i, int j) = 0;

			//Virtual Functions implemented from interface
			virtual void			load		();
			virtual int 			get_width	();
			virtual int 			get_height	();
			virtual	void			draw		( GtkContainer * container );
			virtual void			end			( void );
			
			void			draw_list			( GtkContainer * container ); 
			void 			draw_file_info 	( GtkContainer * container );
			
							~iList();

	private:
			void			scale_image (int max_x = 250, int max_y=250);


};

//==============  CLASS FACTORIES DEFINITIONS================================= //

typedef iList* create_t_list();									//CREATE PLUGIN
typedef void destroy_t_list(iList*);							   	//DESTROY PLUGIN
	
extern map<string, create_t_list *, less<string> > factory_list;		   //MAP WITH NAME AND CONSTRUCTOR
extern map<string, destroy_t_list *, less<string> > factoryDestroy_list; //MAP WITH NAME AND DESTRUCTOR
extern vector<plugin_filetype> pluginVector;				   		 	   //VECTOR TO STORE WICH FILETYPE READ EACH PLUGIN

#endif
