#include "gloobus-preview-interface-video.h"

// @param obj This is the pointer to the class that will call the function load2
//
// =========================== LAUNCH MEMBER FUNCTION ======================================== //
// Trick to launch a the play function, after the widget is created <g_idle_add> 
static gboolean LaunchMemberFunction(void *obj)
{
    iMovie *myObj = reinterpret_cast<iMovie *>(obj);
    myObj->play();
    myObj->create_timeout();
    return FALSE;
};


// =========================== ~iMOVIE ======================================== //
iMovie::~iMovie()
{
	g_source_remove(m_timeout_id);
}
//============================= END =========================================== //
void iMovie::end()
{

}

void iMovie::load() {;}
int  iMovie::get_width	() { return 725;}   
int  iMovie::get_height	() { return 500+35;}	//SEEK BAR SPACE

// ======================= DRAW ================================== //
void iMovie::draw ( GtkContainer * container )
{
	draw_movie		( GTK_CONTAINER(container) );
	draw_controls	( GTK_CONTAINER(container) );

}

// ======================= DRAW MOVIE ================================== //
void iMovie::draw_movie(GtkContainer * container)
{
	GdkColormap *colormap;   			// in this Main Function
	GdkScreen 	*screen;
	screen 	 = gdk_screen_get_default 	   (); 
	colormap = gdk_screen_get_rgb_colormap(screen);
	gtk_widget_set_default_colormap	( colormap ); 
	
	gtk_widget_push_colormap(colormap);
	m_container = GTK_WIDGET(container);
	
	m_drawable = gtk_drawing_area_new();
	gtk_widget_set_size_request (m_drawable, 725, 500);

	gtk_widget_show(m_drawable);
	gtk_fixed_put(GTK_FIXED(m_container),m_drawable,SHADOW_WIDTH,SHADOW_WIDTH+HEADER_HEIGHT);
	gtk_widget_show (m_drawable);

	//Play when the widgets are created
	g_idle_add(LaunchMemberFunction,this);		//Wait till the windows are created and displayed before
												//Do the movie sync									
	gtk_widget_pop_colormap();
	
	draw_properties ( container, get_file_info_string(), 25 + SHADOW_WIDTH, get_height() + SHADOW_WIDTH + HEADER_HEIGHT); //35 = seek bar
}

// ================================== DRAW CONTROLS =================================== //
void iMovie::draw_controls(GtkContainer * container)
{

		//m_adjustment = gtk_adjustment_new (0, 0, 101, 1, 5, 25);
       	//m_scale = gtk_hscale_new (GTK_ADJUSTMENT (m_adjustment));
		m_scale = gtk_hscale_new_with_range(0,100,1);
		gtk_scale_set_draw_value(GTK_SCALE(m_scale), false);			//Do not draw the numbers
		GtkWidget * hbox = gtk_hbox_new   (false,3);
       	gtk_box_pack_end (GTK_BOX (hbox), m_scale, TRUE, TRUE, 2);
		
	
		gtk_fixed_put			( GTK_FIXED(container),hbox, SHADOW_WIDTH , get_height() );
	    gtk_widget_set_usize	( hbox, get_width()-10,  35);		
		gtk_widget_show_all		( hbox );

		//When the seek bar is moved, change the position
		g_signal_connect (G_OBJECT (m_scale), "change-value", G_CALLBACK (&iMovie::trick), this);
}

// ================================== DRAW POSITION =================================== //
// Request the postion to the plugin and puts the range to this new position
void iMovie::draw_position( void )
{
	gtk_range_set_value (GTK_RANGE (m_scale), get_position());
}

// =========================== CREATE TIMEOUT ================================== //
void iMovie::create_timeout()
{
	 m_timeout_id = g_timeout_add 	(100, &iMovie::trick2,this);				//Get new position
}
