#ifndef _IPHOTO_
#define _IPHOTO_

#define MANAGER_VERSION 1			// TODO: Define here the pluginManager version !!! (In pluginManager.h)
#define PLUGIN_NAME	 	"iPhoto"	// TODO: Define here the plugin Name

#include "../gloobus-preview-interface-image.h"

class iPhoto : public iImage
{
	public:
	virtual 	GdkPixbuf*		get_pixbuf  ();
};



// ============================ Class factories======================================== //
// This is "allways the same" code, just change the plugin name in the printf and the 
// return object
extern "C" iImage* create() {		
	printf("Creating iPhoto...\n");
    return new iPhoto;
}

extern "C" void destroy(iImage* p) {
	printf("Destroying iPhoto...\n");
    delete p;
}

extern "C" int getVersion(){			//To save crashes from older versions
	return MANAGER_VERSION;
}

// ============================== REGISTER ============================================ //
// Here is where we register the new plugin, what we do is to add a map with the plugin
// name and the mime file types it can load, then, the pluginManager will take care of wich
// plugin load, depending on its file type. Just add more than one file type adding this
// two lines as many times you want.
//
//	itself.filetype = "image/bmp";			// Add another extension supported
//	pluginVector.push_back(itself);			// Add filetype that plugin reads

extern "C" 
{
   class proxy {
		public:
	   	proxy()
		{
			//plugin_filetype itself = {PLUGIN_NAME,EXTENSION,TYPE,PRIORITY}
			//The priority is used to know wich plugin use if there are more than one that can handle the same
			//filetype, 1 is the lower priority
			//TODO: Add here the mime filetypes that plugin supports
			//plugin_filetype_itself = { NAME OF PLUGIN, MIME TYPE IT SUPPORTS, INHERTED CLASS, PRIORITY}

			plugin_filetype itself = { PLUGIN_NAME, "image/jpeg","image",1};		// Initial filetype

			factory_image[itself.name] = create;		    // Register the plugin
			factoryDestroy_image[itself.name] = destroy;	// Function for destroy this plugin class
			pluginVector.push_back(itself);					// Add filetype that plugin reads
		    
		    itself.filetype = "image/png";			// Add another extension supported
			pluginVector.push_back(itself);			// Add filetype that plugin reads
			itself.filetype = "image/bmp";			// Add another extension supported
			pluginVector.push_back(itself);			// Add filetype that plugin reads
			itself.filetype = "image/gif";			// Add another extension supported
			pluginVector.push_back(itself);			// Add filetype that plugin reads
			itself.filetype = "image/svg+xml";			// Add another extension supported
			pluginVector.push_back(itself);			// Add filetype that plugin reads
			itself.filetype = "image/vnd.adobe.photoshop";		//This needs PSD loader
			pluginVector.push_back(itself);		
			itself.filetype = "image/x-xcf";					//This needs XCF loader
			pluginVector.push_back(itself);			
			itself.filetype = "image/x-compressed-xcf";			//This needs XCF loader
			pluginVector.push_back(itself);			
	   }
 };
 proxy p;	// When we open the dll with RTLD_NOW it creates p, and in consequence, it registers the plugin 
}

#endif

